// Copyright 1997-2001 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.
//
// $Header: /Network/Source/CVS/OmniGroup/Frameworks/OmniAppKit/OAApplication.h,v 1.15 2001/02/15 15:12:28 kc Exp $

#import <AppKit/NSApplication.h>

@class NSDate, NSException;

#import <Foundation/NSDate.h> // For NSTimeInterval
#import <AppKit/NSNibDeclarations.h> // For IBAction

@interface OAApplication : NSApplication
{
    NSDate *exceptionCheckpointDate;
    unsigned int exceptionCount;
    NSTimeInterval lastEventTimeInterval;
    unsigned int mouseButtonState;
}

- (void)handleInitException:(NSException *)anException;
- (void)handleRunException:(NSException *)anException;

- (NSTimeInterval)lastEventTimeInterval;
- (BOOL)mouseButtonIsDownAtIndex:(unsigned int)mouseButtonIndex;
- (BOOL)scrollWheelButtonIsDown;

// Actions
- (IBAction)closeAllMainWindows:(id)sender;
- (IBAction)miniaturizeAll:(id)sender;
- (IBAction)cycleToNextMainWindow:(id)sender;
- (IBAction)cycleToPreviousMainWindow:(id)sender;

@end
